import type { FirestoreDocument } from './../firestore/FirestoreDocument';
import type { SupportedRegion } from 'firebase-functions/v2/options';
import type { FirebaseFunctions } from '../firebase';
import { FirebaseFunctionsCaller } from './FirebaseFunctionsCaller';
import type { FirebaseApp as FirebaseAppInstance } from 'firebase/app';
import { FirebaseAuthenticator } from './FirebaseAuthenticator';
import { FirebaseFirestoreDocument } from './FirebaseFirestore';
export declare class FirebaseApp<Functions extends FirebaseFunctions, FirestoreScheme extends FirestoreDocument<any, any>> {
    private readonly options;
    constructor(options: FirebaseApp.Options);
    get functions(): FirebaseFunctionsCaller<Functions>;
    get firestore(): FirebaseFirestoreDocument<FirestoreScheme>;
    get auth(): FirebaseAuthenticator;
}
export declare namespace FirebaseApp {
    interface Options {
        macKey: Uint8Array;
        app: FirebaseAppInstance;
        region: SupportedRegion;
        useFunctionsEmulatorPort: number | null;
        requestBaseUrl: string;
        useAuthEmulatorPort: number | null;
        useFirestoreEmulatorPort: number | null;
    }
}
