"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FirebaseApp = void 0;
const FirebaseFunctionsCaller_1 = require("./FirebaseFunctionsCaller");
const FirebaseAuthenticator_1 = require("./FirebaseAuthenticator");
const FirebaseFirestore_1 = require("./FirebaseFirestore");
const firestore_1 = require("../firestore");
class FirebaseApp {
    options;
    constructor(options) {
        this.options = options;
    }
    get functions() {
        return new FirebaseFunctionsCaller_1.FirebaseFunctionsCaller(this.options);
    }
    get firestore() {
        return new FirebaseFirestore_1.FirebaseFirestoreDocument(this.options, new firestore_1.FirestorePath());
    }
    get auth() {
        return new FirebaseAuthenticator_1.FirebaseAuthenticator(this.options);
    }
}
exports.FirebaseApp = FirebaseApp;
