"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FirebaseAuthenticator = void 0;
const auth_1 = require("firebase/auth");
class FirebaseAuthenticator {
    options;
    constructor(options) {
        this.options = options;
    }
    get authInstance() {
        const authInstance = (0, auth_1.getAuth)(this.options.app);
        if (this.options.useAuthEmulatorPort !== null)
            (0, auth_1.connectAuthEmulator)(authInstance, `http://127.0.0.1:${this.options.useAuthEmulatorPort}`);
        return authInstance;
    }
    async createUser(email, password) {
        return (0, auth_1.createUserWithEmailAndPassword)(this.authInstance, email, password);
    }
    async signIn(email, password) {
        return (0, auth_1.signInWithEmailAndPassword)(this.authInstance, email, password);
    }
}
exports.FirebaseAuthenticator = FirebaseAuthenticator;
